﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;

namespace GridVirtualization
{
    public sealed class DataModel
    {
        public static IEnumerable<AbstractPicture> GetImages()
        {
            var images = 90;
            for (int j = 0; j < 10; j++)
            {
                for (int i = 0; i < images; i++)
                {
                    var number = j * images + i + 1;
                    yield return new AbstractPicture
                    {
                        Id = i + 1,
                        Title = "Picture title #" + number,
                        Description = "description #" + number,
                        Location = new BitmapImage(new Uri("ms-appx:///" + "Assets/image" + (i + 1).ToString("D3") + ".jpg"))
                    };

                }
            }
        }
    }

    public sealed class AbstractPicture
    {
        public int Id { get; set; }
        public string Title { get; set; }
        public string Description { get; set; }
        public ImageSource Location { get; set; }
    }


}
