﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml.Data;

namespace GridVirtualization
{
    public sealed class ViewModel
    {
        public ObservableCollection<AbstractPicture> Images = new ObservableCollection<AbstractPicture>();

        public CollectionViewSource GroupedImages = new CollectionViewSource();

        public void GetImages()
        {
            Images = new ObservableCollection<AbstractPicture>(DataModel.GetImages());
        }

        public void GroupImages()
        {
            GroupedImages.IsSourceGrouped = true;
            GroupedImages.Source = from m in DataModel.GetImages()
                                   group m by "Group #" + ((m.Id % 5) + 1).ToString() into g
                                   orderby g.Key
                                   select g;
        }
    }
}
