using System;
using System.Threading;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace CancelTask
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        // input for Fibonacci calculation
        private int Counter = 35;

        private CancellationTokenSource Cts;

        private async void Calculate_Click(object sender, RoutedEventArgs e)
        {
            Cts = new CancellationTokenSource();

            try
            {
                Output.Text = (await LongRunningComputationAsync(Cts.Token)).ToString();
            }
            catch (OperationCanceledException)
            {
                Output.Text = "Cancelled";
            }
        }

        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            Cts.Cancel();
        }

        private Task<int> LongRunningComputationAsync(CancellationToken token)
        {
            return Task.Run(() => RecursiveFibonacci(Counter++, token), token);
        }

        // Very ineffective implementation of Fibonacci
        // For illustration purposes only - Don't use!
        private int RecursiveFibonacci(int n, CancellationToken token)
        {
            if (n <= 1)
            {
                return 1;
            }

            token.ThrowIfCancellationRequested();

            return RecursiveFibonacci(n - 2, token) + RecursiveFibonacci(n - 1, token);
        }
    }
}
