// TriggerPrefetch.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <IContentPrefetcherTaskTrigger.h>
#include <roapi.h>
#include <winstring.h>

int _tmain(int argc, _TCHAR* argv[])
{
    WCHAR* activableClass = L"Windows.Networking.BackgroundTransfer.ContentPrefetcher";
    int iLen = wcslen(activableClass);
    HSTRING hs_activableClass;
    int rc = 0;
    if (argc > 1) {
        if (SUCCEEDED(WindowsCreateString(activableClass, iLen, &hs_activableClass))) {
            if (SUCCEEDED(RoInitialize(RO_INIT_MULTITHREADED)))
            {
                IContentPrefetcherTaskTrigger *trigger = nullptr;
                if (SUCCEEDED(Windows::Foundation::GetActivationFactory(hs_activableClass,
                    &trigger))) {
                    // supply PackageFullName at prompt, retrieve the name by running
                    // Get-AppxPackage cmdlet
                    if (FAILED(trigger->TriggerContentPrefetcherTask(argv[1]))) {
                        // log error and set bad return value
                        rc = -1;
                    }
                    trigger->Release();
                }
            }
            RoUninitialize();
        }
        if (FAILED(WindowsDeleteString(hs_activableClass))) {
            // log error and set bad return value
            rc = -2;
        }
    }
    else {
        printf("Syntax: TriggerPrefetch <PackageFullName>\n");
    }
    return rc;
}