private async Task SetDataContext()
{
    photos = new ObservableCollection<Photo>();

    if (photosCache != null)
    {
        DataContext = photosCache;
    }
    else
    {
        DataContext = photos;
    }
    
    var pictures = KnownFolders.PicturesLibrary;
    
    foreach (var file in await pictures.GetFilesAsync())
    {
        var thumbnail = await file.GetThumbnailAsync(ThumbnailMode.PicturesView);
    
        if (thumbnail != null)
        {
            using (thumbnail)
            {
                var source = new BitmapImage();
                await source.SetSourceAsync(thumbnail);
        
                photos.Add(new Photo { Thumbnail = source });
            }
        }
    }
    
    photosCache = photos;
}